﻿'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACT距離計算サービス サンプルプログラム
'   MyApplicationクラス
'
'   Copyrights (c) 2010-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2009/09/17 Rev.2.1.1.0 ISHI 新規作成
'
'//////////////////////////////////////////////////////////////////////////////////////////////////
Imports System.Text.RegularExpressions

Namespace My

    ' 次のイベントは MyApplication に対して利用できます:
    ' 
    ' Startup: アプリケーションが開始されたとき、スタートアップ フォームが作成される前に発生します。
    ' Shutdown: アプリケーション フォームがすべて閉じられた後に発生します。このイベントは、通常の終了以外の方法でアプリケーションが終了されたときには発生しません。
    ' UnhandledException: ハンドルされていない例外がアプリケーションで発生したときに発生するイベントです。
    ' StartupNextInstance: 単一インスタンス アプリケーションが起動され、それが既にアクティブであるときに発生します。 
    ' NetworkAvailabilityChanged: ネットワーク接続が接続されたとき、または切断されたときに発生します。
    Partial Friend Class MyApplication

        ''' <summary>
        ''' アプリケーション起動時
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks></remarks>
        Private Sub MyApplication_Startup(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupEventArgs) Handles Me.Startup

            '	Super Mapple Digital インストールのチェック
            Dim smdExist As Boolean = False                                 '	Super Mapple Digital インストールフラグ

            Using smdKey As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey(Constants.RegKeySmdMain)
                If Not smdKey Is Nothing Then
                    '	指定レジストリが見つかった場合
                    Dim subkeyNames As String() = smdKey.GetSubKeyNames()   '	サブキー名を取得する
                    Dim subkeyNameCount As Int32 = subkeyNames.Length       '	サブキー名数の取得
                    Dim smdMajorVersion As Int32 = 0                        '  メジャーバージョン番号
                    For i As Int32 = 0 To subkeyNameCount - 1

                        '	サブキー名からメジャーバージョンを取得する
                        Dim regexVersion As Regex = New Regex("Version (\d+)(?:\.\d+){0,}")
                        Dim matchVersion As Match = regexVersion.Match(subkeyNames(i))
                        If matchVersion.Success Then
                            smdMajorVersion = Convert.ToInt32(matchVersion.Groups(1).Value)
                            If smdMajorVersion >= 11 Then
                                ' バージョン１１以降の場合
                                smdExist = True
                                Exit For
                            ElseIf smdMajorVersion = 10 Then
                                ' バージョン１０の場合サービスパックバージョンも確認する
                                Using smdSubKey As Microsoft.Win32.RegistryKey = smdKey.OpenSubKey(subkeyNames(i) + Constants.RegKeySmdSub)
                                    If Not smdSubKey Is Nothing Then
                                        ' 指定レジストリが見つかった場合
                                        ' サーピスパックのバージョンを取得する
                                        Dim spVersion As String = smdSubKey.GetValue(Constants.RegValueNameSmdSp).ToString()
                                        Dim regexSP As Regex = New Regex("(\d+)(?:\.\d+){0,}")
                                        Dim matchSP As Match = regexSP.Match(spVersion)
                                        If matchSP.Success Then
                                            If Convert.ToInt32(matchSP.Groups(1).Value) >= 2 Then
                                                ' バージョン２以降
                                                smdExist = True
                                                Exit For
                                            End If
                                        End If
                                    End If
                                End Using
                            End If
                        End If
                    Next
                End If

            End Using

            If Not smdExist Then
                '	レジストリが見つからなかった場合
                MessageBox.Show("Super Mapple Digital 10 SP2以降がインストールされていません。" + vbCrLf + "アプリケーションを終了します。", _
                                "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                e.Cancel = True '	アプリケーションの終了
                Return
            End If
        End Sub

    End Class

End Namespace

