'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACTvZT[rX TvvO
'   INIt@CNX
'
'   Copyrights (c) 2004-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2004/09/09 Rev.1.00    TAT ō쐬
'   2004/12/28 Rev.1.01    RIN C^[tFCX̏C
'   2010/09/16 Rev.2.1.1.0 ISHI RgC
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

Imports System.Runtime.InteropServices
Imports System.Text
Imports System.IO

''' <summary>
''' INIt@CNX
''' </summary>
''' <remarks></remarks>
Public Class IniFile

    '----------------------------------------------------------------------------------------------
    '	Win32 API
    '----------------------------------------------------------------------------------------------
#Region "Win32 API"

    ''' <summary>
    ''' ANSI GetPrivateProfileString
    ''' </summary>
    ''' <param name="lpszSectionName"></param>
    ''' <param name="lpszKeyName"></param>
    ''' <param name="lpszDefault"></param>
    ''' <param name="lpszReturnedString"></param>
    ''' <param name="nSize"></param>
    ''' <param name="lpszFileName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszDefault As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszReturnedString As StringBuilder, _
        ByVal nSize As Int32, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32

    ''' <summary>
    ''' ANSI GetPrivateProfileInt
    ''' </summary>
    ''' <param name="lpszSectionName"></param>
    ''' <param name="lpszKeyName"></param>
    ''' <param name="nDefault"></param>
    ''' <param name="lpszFileName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        ByVal nDefault As Int32, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32

    ''' <summary>
    ''' ANSI WritePrivateProfileString
    ''' </summary>
    ''' <param name="lpszSectionName"></param>
    ''' <param name="lpszKeyName"></param>
    ''' <param name="lpszString"></param>
    ''' <param name="lpszFileName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszString As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32

#End Region

    '----------------------------------------------------------------------------------------------
    '	Constants
    '----------------------------------------------------------------------------------------------
#Region "Constants"

    ''' <summary>
    ''' INIt@C̊gq
    ''' </summary>
    ''' <remarks></remarks>
    Private Const ExtentionIniFile_ As String = ".ini"

    ''' <summary>
    ''' obt@񒷂̍ől
    ''' </summary>
    ''' <remarks></remarks>
    Private Const BufferLengthMax_ As Int32 = 520 + 1

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Fields
    '----------------------------------------------------------------------------------------------
#Region "Private Fields"

    ''' <summary>
    ''' AvP[VtH_pX
    ''' </summary>
    ''' <remarks></remarks>
    Private Shared appPath_ As String

    ''' <summary>
    ''' INIt@C
    ''' </summary>
    ''' <remarks></remarks>
    Private Shared fileName_ As String

#End Region

    '----------------------------------------------------------------------------------------------
    '	Constructor
    '----------------------------------------------------------------------------------------------
#Region "Constructor"

    '   LRXgN^
    Shared Sub New()

        '   AvP[Vt@C̏擾
        Dim AppFileInfo As New FileInfo(System.Reflection.Assembly.GetExecutingAssembly().Location)

        '   AvP[VtH_̃pXݒ肷
        appPath_ = AppFileInfo.DirectoryName

        '   INIt@Cݒ肷iAvP[Vt@C̊gqiniɂ́j
        fileName_ = String.Concat(Path.GetFileNameWithoutExtension(AppFileInfo.FullName), ExtentionIniFile_)

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Public Methods
    '----------------------------------------------------------------------------------------------
#Region "Public Methods"

    ''' <summary>
    ''' INIt@C̎w肵ZNṼL[當擾
    ''' </summary>
    ''' <param name="sectionName">ZNV</param>
    ''' <param name="keyName">L[</param>
    ''' <param name="defaultValue">INIt@C݂ȂꍇɕԂl</param>
    ''' <returns>
    ''' w肵L[̕(Ggꍇ)
    ''' defaultValue(GgȂꍇ)
    ''' ̕(defaultValue  Nothing w肳Ăꍇ)
    ''' </returns>
    ''' <remarks></remarks>
    Public Shared Function GetProfileString(ByVal sectionName As String, ByVal keyName As String, ByVal defaultValue As String) As String
        Dim returnString As StringBuilder = New StringBuilder(BufferLengthMax_)

        If Not defaultValue Is Nothing Then
            '   ftHglw肳Ă
            GetPrivateProfileString(sectionName, keyName, defaultValue, returnString, _
                                    returnString.Capacity, Path.Combine(appPath_, fileName_))
        Else
            '   ftHglw肳ĂȂ
            GetPrivateProfileString(sectionName, keyName, "", returnString, _
                                    returnString.Capacity, Path.Combine(appPath_, fileName_))
        End If

        Return returnString.ToString()
    End Function

    ''' <summary>
    ''' INIt@C̎w肵ZNṼL[琔l擾
    ''' </summary>
    ''' <param name="sectionName">ZNV</param>
    ''' <param name="keyName">L[</param>
    ''' <param name="defaultValue">INIt@C݂ȂꍇɕԂl</param>
    ''' <returns>
    ''' w肵L[̐l(Ggꍇ)
    ''' defaultValue(GgȂꍇ)
    ''' 0(GgɑΉlłȂꍇ)
    ''' </returns>
    ''' <remarks></remarks>
    Public Shared Function GetProfileInt(ByVal sectionName As String, ByVal keyName As String, ByVal defaultValue As Int32) As Int32
        Return GetPrivateProfileInt(sectionName, keyName, defaultValue, Path.Combine(appPath_, fileName_))
    End Function

    ''' <summary>
    ''' INIt@C̎w肵ZNṼL[ɕݒ肷
    ''' </summary>
    ''' <param name="sectionName">ZNV</param>
    ''' <param name="keyName">L[</param>
    ''' <param name="value">ݒ肷镶</param>
    ''' <returns>
    ''' ̐ݒɐꍇA0ȊOB
    ''' ̐ݒɎsꍇA0B
    ''' </returns>
    ''' <remarks></remarks>
    Public Shared Function WriteProfileString(ByVal sectionName As String, ByVal keyName As String, ByVal value As String) As Int32
        Return WritePrivateProfileString(sectionName, keyName, value, Path.Combine(appPath_, fileName_))
    End Function

    ''' <summary>
    ''' INIt@C̎w肵ZNṼL[ɐlݒ肷
    ''' </summary>
    ''' <param name="sectionName">ZNV</param>
    ''' <param name="keyName">L[</param>
    ''' <param name="value">ݒ肷鐔l</param>
    ''' <returns>
    ''' l̐ݒɐꍇA0ȊOB
    ''' l̐ݒɎsꍇA0B
    ''' </returns>
    ''' <remarks></remarks>
    Public Shared Function WriteProfileInt(ByVal sectionName As String, ByVal keyName As String, ByVal value As Int32) As Int32
        Return WritePrivateProfileString(sectionName, keyName, value.ToString(), Path.Combine(appPath_, fileName_))
    End Function

    ''' <summary>
    ''' INIt@Cݒ(ύX)
    ''' </summary>
    ''' <param name="fileName">INIt@C</param>
    ''' <remarks></remarks>
    Public Shared Sub SetFileName(ByVal fileName As String)
        fileName_ = fileName
    End Sub

#End Region

End Class

