﻿'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACT距離計算サービス サンプルプログラム
'   住所選択フォームクラス
'
'   Copyrights (c) 2010-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2010/12/03 Rev.2.1.2.0 ISHI 公開
'   2011/08/25 Rev.2.2.0.0 ISHI 住所検索サービス新関数対応
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

''' <summary>
''' 住所選択フォーム
''' </summary>
''' <remarks></remarks>
Public Class SelectAddressForm
    '----------------------------------------------------------------------------------------------
    '	Private Fields
    '----------------------------------------------------------------------------------------------
#Region "Private Fields"

    ''' <summary>
    ''' 選択候補の郵便番号アイテム配列
    ''' </summary>
    Private zipItems_ As GCService.ZipItem()

#End Region

    '----------------------------------------------------------------------------------------------
    '	Properties
    '----------------------------------------------------------------------------------------------
#Region "Properties"

    ''' <summary>
    ''' リストビューで選択された郵便番号アイテムを取得する
    ''' </summary>
    Public ReadOnly Property SelectedItem() As GCService.ZipItem
        Get
            Return Me.zipItems_(listViewAddress.SelectedIndices(0))
        End Get
    End Property

#End Region

    '----------------------------------------------------------------------------------------------
    '	Public Methods
    '----------------------------------------------------------------------------------------------
#Region "Public Methods"

    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    ''' <param name="zipItems">選択候補の郵便番号アイテム配列</param>
    Sub New(ByVal zipItems As GCService.ZipItem())

        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me.zipItems_ = zipItems

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Event Handlers
    '----------------------------------------------------------------------------------------------
#Region "Event Handlers"

    ''' <summary>
    ''' フォームロード時
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SelectAddressForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' 住所一覧表示
        For Each zipItem As GCService.ZipItem In Me.zipItems_
            Dim item As New ListViewItem(zipItem.Zip)   ' 郵便番号
            item.SubItems.Add(zipItem.FullAddress)      ' 住所
            item.SubItems.Add(zipItem.Lon)              ' 経度
            item.SubItems.Add(zipItem.Lat)              ' 緯度
            listViewAddress.Items.Add(item)
        Next
    End Sub

    ''' <summary>
    ''' リストビューのアイテム選択状態変更時
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub listViewAddress_ItemSelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ListViewItemSelectionChangedEventArgs) Handles listViewAddress.ItemSelectionChanged
        If e.IsSelected Then
            buttonOK.Enabled = True
        Else
            buttonOK.Enabled = False
        End If
    End Sub

    ''' <summary>
    ''' リストビューダブルクリック時
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub listViewAddress_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles listViewAddress.MouseDoubleClick
        ' 選択アイテムが一つある場合は選択完了
        If listViewAddress.SelectedIndices.Count = 1 Then
            buttonOK.PerformClick()
        End If
    End Sub

#End Region

End Class