﻿'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'  ACT距離計算サービス サンプルプログラム
'  ユーティリティクラス
'
'  Copyrights (c) 2011 Advanced Core Technologies, Inc. All rights reserved.
'
'  2011/04/26 Rev.2.2.0.0 ISHI 公開
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

''' <summary>
''' ユーティリティクラス
''' </summary>
Module Utilities

    ''' <summary>
    ''' URLのプロトコルをSSLモードによって変更する
    ''' </summary>
    ''' <param name="url">変更するURL</param>
    ''' <param name="sslMode">SSLモード</param>
    ''' <returns>変更後のURL</returns>
    Public Function ChangeProtocol(ByVal url As String, ByVal sslMode As Boolean) As String
        Dim uri As Uri = New Uri(url)
        Dim protocol As String = If(sslMode, "https", "http")
        Return String.Format("{0}://{1}{2}", protocol, uri.Host, uri.AbsolutePath)
    End Function

    ''' <summary>
    ''' 管理サービス用環境設定オブジェクトから距離計算サービス環境設定オブジェクトを取得する
    ''' </summary>
    ''' <param name="adminEnviron">管理サービス用環境設定オブジェクト</param>
    ''' <returns>距離計算サービス環境設定オブジェクト</returns>
    Public Function GetDCServiceEnviron(ByVal adminEnviron As DCAdmin.Environ) As DCService.Environ
        Dim dcEnviron As DCService.Environ = New DCService.Environ()    '  距離計算サービス環境設定オブジェクト
        dcEnviron.UserID = adminEnviron.UserID                          '  ユーザID
        dcEnviron.UUID = adminEnviron.UUID                              '  パスワード
        dcEnviron.Host = adminEnviron.Host                              '  リスナIPアドレス
        dcEnviron.Port = adminEnviron.Port                              '  リスナポート番号
        Return dcEnviron
    End Function

    ''' <summary>
    ''' 管理サービス用環境設定オブジェクトから住所検索サービス環境設定オブジェクトを取得する
    ''' </summary>
    ''' <param name="adminEnviron">管理サービス用環境設定オブジェクト</param>
    ''' <returns>距離計算サービス環境設定オブジェクト</returns>
    Public Function GetGCServiceEnviron(ByVal adminEnviron As DCAdmin.Environ) As GCService.Environ
        Dim gcEnviron As GCService.Environ = New GCService.Environ()    '  住所検索サービス環境設定オブジェクト
        gcEnviron.UserID = adminEnviron.UserID                          '  ユーザID
        gcEnviron.UUID = adminEnviron.UUID                              '  パスワード
        gcEnviron.Host = adminEnviron.Host                              '  リスナIPアドレス
        gcEnviron.Port = adminEnviron.Port                              '  リスナポート番号
        Return gcEnviron
    End Function

End Module
